/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.benutzerverwaltung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.benutzerverwaltung.boundary.AbstractBenutzerSearchParameters;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerChangeEvent;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerConversationStore;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerExtendedDAO;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerSearch;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractBenutzerSearchView.COMPONENT_NAME)
@View(viewId = AbstractBenutzerSearchView.VIEW_ID, useCase = UseCasePermission.BENUTZER_SEARCH)
public abstract class AbstractBenutzerSearchView extends AbstractElectSearchView<Benutzer> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerSearchView";
  
  public static final String VIEW_ID = "/benutzerverwaltung/benutzer-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractBenutzerSearchView requestHandler;

  @Inject
  private transient BenutzerExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(BenutzerConversationStore.class)
  protected transient BenutzerConversationStore conversationStore;

  @Inject
  protected transient BenutzerSearch search;

  @Inject
  @ConversationGroup(AbstractBenutzerSearchParameters.class)
  protected transient BenutzerSearchParameters searchParameters;

  @Inject
  protected transient BenutzerMeta entityMeta;

  public AbstractBenutzerSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Benutzer getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Benutzer entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public BenutzerSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Benutzer> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Benutzer> create();
  }

  @Override
  public List<Benutzer> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Benutzer> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onBenutzerChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) BenutzerChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractBenutzerSearchView {

    @View
    @Inject
    private transient Instance<AbstractBenutzerSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractBenutzerSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
